args "--no-version --no-help"

purpose "Synchronize playback between multiple clients."

option "buddy" b
#~~~~~~~~~~~~~~~
"host to synchronize with"
multiple
string typestr = "url"
optional
details = "
	This option may be given multiple times, one per buddy. Each
	value may be given as a host, port pair in either IPv4 or
	IPv6 form, with port being optional. If no port was specified
	the listening port (as specified with --port, see below)
	is used to send the synchronization packet to this buddy.
"

option "port" p
#~~~~~~~~~~~~~~
"UDP port for incoming synchronization packets"
int typestr = "portnumber"
default = "29900"
optional
details = "
	The sync filter receives incoming synchronization packets on
	this UDP port.
"

option "timeout" t
#~~~~~~~~~~~~~~~~~
"how long to wait for other clients"
int typestr = "milliseconds"
default = "2000"
optional
details = "
	Once the sync filter receives its first chunk of input, a
	synchronization period of the given number of milliseconds
	begins. Playback is deferred until a synchronization packet
	has been received from each defined buddy, or until the end
	of the period. Buddies which did not send a synchronization
	packet in time are temporarily disabled and are not waited for
	during subsequent synchronization periods. They are re-enabled
	automatically when another synchronization packet arrives.
"
